
var cron = require('../cron');

describe('zero-encoding/cron', function () {
    var cronObj;
    it('cron.parse(expression)', function () {
        cronObj = cron.parse('*/10 * * * *');
        expect(cronObj.minute.interval).toEqual({
            from: 0,
            step: 10
        });
        expect(cronObj.minute.all).toEqual([0, 10, 20, 30, 40, 50]);

        cronObj = cron.parse('30 21 * * *');
        expect(cronObj.minute.select).toEqual([30]);
        expect(cronObj.hour.select).toEqual([21]);

        cronObj = cron.parse('0 11 4 * mon-wed');
        expect(cronObj.hour.select).toEqual([11]);
        expect(cronObj.minute.select).toEqual([0]);
        expect(cronObj.dayOfWeek.range).toEqual({
            from: 1,
            to: 3
        });
        expect(cronObj.dayOfWeek.all).toEqual([1, 2, 3]);

        cronObj = cron.parse('0 4 1 jan *');
        expect(cronObj.hour.select).toEqual([4]);
        expect(cronObj.minute.select).toEqual([0]);
        expect(cronObj.dayOfMonth.select).toEqual([1]);
        expect(cronObj.month.select).toEqual([1]);
        expect(cronObj.month.all).toEqual([1]);

        cronObj = cron.parse('*/15 8-16,3 * * *');
        expect(cronObj.hour.all).toEqual([8, 9, 10, 11, 12, 13, 14, 15, 16, 3]);
        expect(cronObj.minute.all).toEqual([0, 15, 30, 45]);
    });

    it('cron.stringify(cronObj)', function () {
        expect(cron.stringify(cron.parse('* 10,20,30 * * * *'))).toEqual('* 10,20,30 * * * *');
    });
});

