
var json = require('../json');
var type = require('zero-lang/type');

var strJSON = '{"kitcambridge":"Kit","contributors":{"jdalton":"John-David","mathias":"Mathias"},"list":[1,2,3],"number":5,"date":"2012-04-25T14:08:36.879Z","boolean":true,"nil":null}';
var objJSON = {
    "kitcambridge":"Kit",
    "contributors":{
        "jdalton":"John-David",
        "mathias":"Mathias"
    },
    "list":[ 1, 2, 3 ],
    "number":5,
    "date":"2012-04-25T14:08:36.879Z",
    "boolean":true,
    "nil":null
};

describe('zero-encoding/json.parse()', function () {
    it('json.parse(str, strict)', function () {
        expect(json.parse(strJSON)).toEqual(objJSON);
    });
});

describe('zero-encoding/json.stringify()', function () {
    it('json.stringify(value, replacer, spacer)', function () {
        expect(json.stringify(objJSON)).toEqual(strJSON);
    });
});

describe('bug in Firefox 3.5/Gecko 1.9', function () {
    it('bug in Firefox 3.5/Gecko 1.9', function () {
        expect(
            json.stringify({
                x   : 1,
                arr : [1]
            }, function (k, v) {
                return type.isNumber(v) ? 3 : v;
            })
        ).toEqual('{"x":3,"arr":[3]}');
    });
});

